import 'dart:async';
import 'package:built_collection/built_collection.dart';
import 'package:flutter/widgets.dart';
import 'package:flutter/services.dart';
import 'dart:io';
import 'package:mzanalytics_mybmw/mzanalytics_ios.dart';
import 'package:mzanalytics_mybmw/mzanalytics_android.dart';

class MzanalyticsMybmw {
  static const MethodChannel _channel =
      const MethodChannel('mzanalytics_mybmw');

  //ios fuction
  static Future<void> ios_appid(String aid) async {
    try {
      Mzanalytics_ios.appid(aid);
    } on PlatformException {}
  }

  static Future<void> ios_trackPageView(var parameter) async {
    try {
      Mzanalytics_ios.trackPageView(parameter);
    } on PlatformException {}
  }

  static Future<void> ios_trackEvent(var parameter) async {
    try {
      Mzanalytics_ios.trackEvent(parameter);
    } on PlatformException {}
  }

  static Future<void> ios_trackSiteCustomEvent(var parameter) async {
    try {
      Mzanalytics_ios.trackSiteCustomEvent(parameter);
    } on PlatformException {}
  }

  static Future<void> get ios_trackPulse async {
    try {
      Mzanalytics_ios.trackPulse;
    } on PlatformException {}
  }

  static Future<String> get ios_getCid async {
    try {
      final String cid = await Mzanalytics_ios.getCid;
      return cid;
    } on PlatformException {}
  }

  static Future<void> ios_setEnableLog(bool parameter) async {
    try {
      Mzanalytics_ios.setEnableLog(parameter);
    } on PlatformException {}
  }

  static Future<void> ios_handleOpenURL(String url) async {
    try {
      Mzanalytics_ios.handleOpenURL(url);
    } on PlatformException {}
  }

  static Future<void> ios_setCd(var key, var value) async {
    try {
      Mzanalytics_ios.setCd(key, value);
    } on PlatformException {}
  }

  static Future<void> ios_setCm(var key, var value) async {
    try {
      Mzanalytics_ios.setCm(key, value);
    } on PlatformException {}
  }

  static Future<void> ios_deleteCd(var key) async {
    try {
      Mzanalytics_ios.deleteCd(key);
    } on PlatformException {}
  }

  static Future<void> ios_deleteCm(var key) async {
    try {
      Mzanalytics_ios.deleteCm(key);
    } on PlatformException {}
  }

  static Future<Map> ios_getCdAndCm() async {
    try {
      return Mzanalytics_ios.getCdAndCm();
    } on PlatformException {}
  }

  static Future<bool> ios_isAutoTrackpage() async {
    try {
      return Mzanalytics_ios.isAutoTrackpage();
    } on PlatformException {}
  }

  static Future<List> ios_getBlackList() async {
    try {
      return Mzanalytics_ios.getBlackList();
    } on PlatformException {}
  }

  //android fuction

  static Future<void> android_initEvent() async {
    try {
      Mzanalytics_android.initEvent();
    } on PlatformException catch (e) {}
  }

  static Future<void> android_sendBaseEvent(var parameter) async {
    try {
      Mzanalytics_android.android_sendBaseEvent(parameter);
    } on PlatformException catch (e) {}
  }

  static Future<void> android_pageEvent(var parameter) async {
    try {
      Mzanalytics_android.android_pageEvent(parameter);
    } on PlatformException catch (e) {}
  }

  static Future<void> android_seniorEvent(var parameter) async {
    try {
      Mzanalytics_android.android_seniorEvent(parameter);
    } on PlatformException catch (e) {}
  }

  static Future<void> android_heartEvent() async {
    try {
      Mzanalytics_android.android_heartEvent();
    } on PlatformException catch (e) {}
  }

  static Future<String> android_getOaid() async {
    try {
      return Mzanalytics_android.android_getOaid();
    } on PlatformException catch (e) {}
  }

  static Future<String> android_getCid() async {
    try {
      return Mzanalytics_android.android_getCid();
    } on PlatformException catch (e) {}
  }

  static Future<String> android_setCd(var key, var value) async {
    try {
      print("android_d_key:" + key);
      return Mzanalytics_android.android_setCd(key, value);
    } on PlatformException catch (e) {}
  }

  static Future<String> android_setCm(var key, var value) async {
    try {
      print("android_d_key:" + key);
      return Mzanalytics_android.android_setCm(key, value);
    } on PlatformException catch (e) {}
  }

  static Future<String> android_deleteCd(var key) async {
    try {
      print("android_d_key:" + key);
      return Mzanalytics_android.android_deleteCd(key);
    } on PlatformException catch (e) {}
  }

  static Future<String> android_deleteCm(var key) async {
    try {
      return Mzanalytics_android.android_deleteCm(key);
    } on PlatformException catch (e) {}
  }

  static Future<Map> android_getCdAndCm() async {
    try {
      return Mzanalytics_android.android_getCdAndCm();
    } on PlatformException catch (e) {}
  }

  static Future<bool> android_isAutoTrackpage() async {
    try {
      return Mzanalytics_android.isAutoTrackpage();
    } on PlatformException catch (e) {}
  }

  static Future<List> android_getBlackList() async {
    try {
      return Mzanalytics_android.android_getBlackList();
    } on PlatformException catch (e) {}
  }

  /** 自定义cd和cm统一对外方法 */
  static Future<Map> getCdAndCm() async {
    try {
      if (Platform.isAndroid) {
        return android_getCdAndCm();
      } else if (Platform.isIOS) {
        return ios_getCdAndCm();
      }
    } on FileSystemException {
      return null;
    }
  }

  static Future<void> setCd(String cd_key, String cd_value) async {
    try {
      if (Platform.isAndroid) {
        android_setCd(cd_key, cd_value);
      } else if (Platform.isIOS) {
        ios_setCd(cd_key, cd_value);
      }
    } on FileSystemException {}
  }

  static Future<void> setCm(var cm_key, var cm_value) async {
    try {
      if (Platform.isAndroid) {
        android_setCm(cm_key, cm_value);
      } else if (Platform.isIOS) {
        ios_setCm(cm_key, cm_value);
      }
    } on FileSystemException {}
  }

  static Future<void> deleteCd(var cd_key) async {
    try {
      if (Platform.isAndroid) {
        android_deleteCd(cd_key);
      } else if (Platform.isIOS) {
        ios_deleteCd(cd_key);
      }
    } on FileSystemException {}
  }

  static Future<void> deleteCm(var cm_key) async {
    try {
      if (Platform.isAndroid) {
        android_deleteCm(cm_key);
      } else if (Platform.isIOS) {
        ios_deleteCm(cm_key);
      }
    } on FileSystemException {}
  }

  static Future<bool> isAutoTrackpage() async {
    try {
      if (Platform.isAndroid) {
        return android_isAutoTrackpage();
      } else if (Platform.isIOS) {
        return ios_isAutoTrackpage();
      }
    } on FileSystemException {}
  }

  static Future<List> getBlackList() async {
    try {
      if (Platform.isAndroid) {
        return android_getBlackList();
      } else if (Platform.isIOS) {
        return ios_getBlackList();
      }
    } on FileSystemException {}
  }
}

class MZNavigationHistoryObserver extends NavigatorObserver {
  /// A list of all the past routes
  List<Route<dynamic>> _history = <Route<dynamic>>[];

  /// Gets a clone of the navigation history as an immutable list.
  get history => BuiltList<Route<dynamic>>.from(_history);

  /// Gets the top route in the navigation stack.
  get top => _history.last;

  /// A list of all routes that were popped to reach the current.
  List<Route<dynamic>> _poppedRoutes = <Route<dynamic>>[];

  /// Gets a clone of the popped routes as an immutable list.
  get poppedRoutes => BuiltList<Route<dynamic>>.from(_poppedRoutes);

  /// Gets the next route in the navigation history, which is the most recently popped route.
  get next => _poppedRoutes.last;

  /// A stream that broadcasts whenever the navigation history changes.
  StreamController _historyChangeStreamController =
      StreamController.broadcast();

  /// Accessor to the history change stream.
  get historyChangeStream => _historyChangeStreamController.stream;

  static final MZNavigationHistoryObserver _singleton =
      MZNavigationHistoryObserver._internal();
  MZNavigationHistoryObserver._internal();
  factory MZNavigationHistoryObserver() {
    return _singleton;
  }

  @override
  void didPop(Route<dynamic> route, Route<dynamic> previousRoute) {
    _poppedRoutes.add(_history.last);
    _history.removeLast();
    _historyChangeStreamController.add(HistoryChange(
      action: NavigationStackAction.pop,
      newRoute: route,
      oldRoute: previousRoute,
    ));
  }

  @override
  void didPush(Route<dynamic> route, Route<dynamic> previousRoute) {
    _history.add(route);
    _poppedRoutes.remove(route);
    try {
      MzanalyticsMybmw.isAutoTrackpage().then((bool isAutoTrackpage) {
        MzanalyticsMybmw.getBlackList().then((List blackpvList) {
          if (route.settings.name != null &&
              route.settings.name != '/' &&
              isAutoTrackpage &&
              !blackpvList.contains(route.settings.name)) {
            print('sending...');
            Map selfparams = new Map();
            MzanalyticsMybmw.getCdAndCm().then((Map value) {
              print("读取的自定义事件:" + value.toString());
              if (value != null) {
                selfparams = value;
              }
              //{'pageTitle': route.settings.name;CustomDimMetrics:字典}; {'pageTitle': route.settings.name;字典}
              if (Platform.isIOS) {
                //ios相关代码

                selfparams['pageTitle'] = route.settings.name;
                print('准备发送的数据：' + selfparams.toString());

                MzanalyticsMybmw.ios_trackPageView(selfparams);
              } else if (Platform.isAndroid) {
                //android相关代码
                selfparams['dt'] = route.settings.name;
                print('准备发送的数据：' + selfparams.toString());
                MzanalyticsMybmw.android_pageEvent(selfparams);
              }
            });
          }
        });
      });
    } on PlatformException {}
    _historyChangeStreamController.add(HistoryChange(
      action: NavigationStackAction.push,
      newRoute: route,
      oldRoute: previousRoute,
    ));
  }

  @override
  void didRemove(Route<dynamic> route, Route<dynamic> previousRoute) {
    _history.remove(route);
    _historyChangeStreamController.add(HistoryChange(
      action: NavigationStackAction.remove,
      newRoute: route,
      oldRoute: previousRoute,
    ));
  }

  @override
  void didReplace({Route<dynamic> newRoute, Route<dynamic> oldRoute}) {
    int oldRouteIndex = _history.indexOf(oldRoute);
    _history.replaceRange(oldRouteIndex, oldRouteIndex + 1, [newRoute]);
    _historyChangeStreamController.add(HistoryChange(
      action: NavigationStackAction.replace,
      newRoute: newRoute,
      oldRoute: oldRoute,
    ));
  }
}

/// A class that contains all data that needs to be broadcasted through the history change stream.
class HistoryChange {
  HistoryChange({this.action, this.newRoute, this.oldRoute});

  final NavigationStackAction action;
  final Route<dynamic> newRoute;
  final Route<dynamic> oldRoute;
}

enum NavigationStackAction { push, pop, remove, replace }
